library ormicida.core;

/// [Constructor] defines a method that allocate an arbitrary instances.
/// [fields] are used as parameters and may be ignored.
typedef dynamic Constructor(Map<String, dynamic> fields);

/// [InspectableSink] defines the sink to be used by [Inspectable] instances.
abstract class InspectableSink {
  /// Adds a property to the sink.
  /// [name] is the name of the property.
  /// [value] is its value.
  void addProperty(String name, value);
}

/// [Inspectable] defines an interface for instances that can inspect themselves.
abstract class Inspectable {
  /// Inspect the instance, adding its properties to the sink.
  void inspect(InspectableSink sink);
}
